// DynBtnView.cpp : implementation of the CDynBtnView class
//

#include "stdafx.h"
#include "DynBtn.h"

#include "DynBtnDoc.h"
#include "DynBtnView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView

IMPLEMENT_DYNCREATE(CDynBtnView, CView)

BEGIN_MESSAGE_MAP(CDynBtnView, CView)
	//{{AFX_MSG_MAP(CDynBtnView)
	ON_COMMAND(ID_ADD_BUTTON, OnAddButton)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView construction/destruction

CDynBtnView::CDynBtnView()
{
	// TODO: add construction code here

}

CDynBtnView::~CDynBtnView()
{
}

BOOL CDynBtnView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView drawing

void CDynBtnView::OnDraw(CDC* pDC)
{
	CDynBtnDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView printing

BOOL CDynBtnView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDynBtnView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDynBtnView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView diagnostics

#ifdef _DEBUG
void CDynBtnView::AssertValid() const
{
	CView::AssertValid();
}

void CDynBtnView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDynBtnDoc* CDynBtnView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDynBtnDoc)));
	return (CDynBtnDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDynBtnView message handlers

void CDynBtnView::OnAddButton() 
{
	// MG: This is the routine to add a button control, dynamically

	static int UniqueID=3000;	// Controls need a Unique ID
	
	// Just used to make buttons appear in sequential order
	int i = UniqueID-3000;
	CRect Rect( 0, i * 25, 100, i*25+25 );
	
	// The CButton is created here, and never released.  This is a memory
	// leak, which should be resolved in real use.  The main point is
	// this: You do not want the destructor for the CButton called in this
	// function, since it will remove the button from the screen also.
	CButton *TmpBtn = new CButton;
	CString Caption;

	Caption.Format( "Button%d", UniqueID );
	// The Create function creates the on-screen button, and associates it with
	// the CButton object.
	if( TmpBtn->Create( Caption, WS_TABSTOP|WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, Rect, this, UniqueID++ )==0 )
		MessageBox( "Failed" );
	// That's it, the button should now be on screen	
}


BOOL CDynBtnView::PreTranslateMessage(MSG* pMsg) 
{
	// MG: add this function, and the following 2 lines to allow the
	// TAB key to move you from item to item.
	if( IsDialogMessage( pMsg ) )
		return( TRUE );
	
	return CView::PreTranslateMessage(pMsg);
}

// MG: Having an OnCommand method is how you can get the 'click' event
// from the dynamic controls. (Interaction depends on control and the event).
BOOL CDynBtnView::OnCommand(WPARAM wParam, LPARAM lParam) 
{

	// Test for ID range of our buttons
	if( LOWORD(wParam)>=3000 && LOWORD(wParam)<=3128 ) 
	{
		CString Tmp;
		Tmp.Format( "Button%d", LOWORD(wParam) );
		MessageBox( Tmp );
	}
	return CView::OnCommand(wParam, lParam);
}
